000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. 商品マスタ作成.
000020 ENVIRONMENT DIVISION.
000030 INPUT-OUTPUT SECTION.
000040 FILE-CONTROL.
000050     SELECT 商品マスタ ASSIGN TO "商品マスタ.sqlite3"
000060         ORGANIZATION IS INDEXED
000070         ACCESS MODE IS DYNAMIC
000080         RECORD KEY IS Ｍ商品コード
000090         FILE STATUS IS ファイルステータス.
000100*
000110     SELECT 商品マスタＣＳＶ ASSIGN TO "商品マスタ初期データ.CSV"
000120         ORGANIZATION IS LINE SEQUENTIAL.
000130 DATA DIVISION.
000140 FILE SECTION.
000150 FD 商品マスタ.
000160 01 商品マスタレコード.
000170    COPY 商品レコード.
000180 FD 商品マスタＣＳＶ.
000190 01 ＣＳＶレコード          PIC X(100).
000200 WORKING-STORAGE SECTION.
000210 01 ファイルステータス      PIC X(2).
000220 01 ＣＳＶデータ.
000230    COPY 商品レコード REPLACING //Ｍ// BY //ＷＳー//.  *> 部分置換指定。先頭の'Ｍ'を'ＷＳ－'に変える
000240 PROCEDURE DIVISION.
000250 開始処理.
000260     OPEN INPUT 商品マスタＣＳＶ.
000270     OPEN OUTPUT 商品マスタ.
000280*
000290     PERFORM FOREVER
000300*       CSVファイルを読み込む。AT ENDなら終了
000310        READ 商品マスタＣＳＶ
000320           AT END
000330              EXIT PERFORM
000340        END-READ
000350*       CSVレコードの最後にカンマ(',')を付与する。
000360        STRING FUNCTION TRIM(ＣＳＶレコード) "," 
000370           DELIMITED BY SIZE INTO ＣＳＶレコード
000380*       CSVレコードを項目単位に分解(","で区切る)
000390        UNSTRING ＣＳＶレコード
000400           DELIMITED BY ","
000410           INTO ＷＳー商品コード,  ＷＳー商品名, 
000420                ＷＳー商品カテゴリ,ＷＳー仕入先コード, 
000430                ＷＳー仕入単価,    ＷＳー販売単価,
000440                ＷＳー在庫単位,    ＷＳー保証期間, 
000450                ＷＳー登録日,      ＷＳー最終更新日 
000460        DISPLAY "'" ＣＳＶデータ "'"              
000470*       商品マスタへの書き込み
000480        WRITE 商品マスタレコード FROM ＣＳＶデータ
000490        IF ファイルステータス NOT = "00"
000500           DISPLAY "マスタファイル書き込みエラー "
000510            "ファイルステータス=" ファイルステータス
000520        END-IF
000530     END-PERFORM.
000540*
000550     CLOSE 商品マスタＣＳＶ.
000560     CLOSE 商品マスタ.
000570     STOP RUN.