000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. 在庫マスタ作成.
000020 ENVIRONMENT DIVISION.
000030 INPUT-OUTPUT SECTION.
000040 FILE-CONTROL.
000050     SELECT 在庫マスタ ASSIGN TO "在庫マスタ.sqlite3"
000060         ORGANIZATION IS INDEXED
000070         ACCESS MODE IS DYNAMIC
000080         RECORD KEY IS Ｍ商品コード
000090         FILE STATUS IS ファイルステータス.
000100*
000110     SELECT 在庫マスタＣＳＶ ASSIGN TO "在庫マスタ初期データ.CSV"
000120         ORGANIZATION IS LINE SEQUENTIAL.
000130 DATA DIVISION.
000140 FILE SECTION.
000150 FD 在庫マスタ.
000160 01 在庫マスタレコード.
000170    COPY 在庫レコード.
000180 FD 在庫マスタＣＳＶ.
000190 01 ＣＳＶレコード          PIC X(100).
000200 WORKING-STORAGE SECTION.
000210 01 ファイルステータス      PIC X(2).
000220 01 ＣＳＶデータ.
000230    COPY 在庫レコード REPLACING //Ｍ// BY //ＷＳー//.  *> 部分置換指定。先頭の'Ｍ'を'ＷＳ－'に変える
000240 PROCEDURE DIVISION.
000250 開始処理.
000260     OPEN INPUT 在庫マスタＣＳＶ.
000270     OPEN OUTPUT 在庫マスタ.
000280*
000290     PERFORM FOREVER
000300*       CSVファイルを読み込む。AT ENDなら終了
000310        READ 在庫マスタＣＳＶ
000320           AT END
000330              EXIT PERFORM
000340        END-READ
000350*       CSVレコードの最後にカンマ(',')を付与する。
000360        STRING FUNCTION TRIM(ＣＳＶレコード) "," 
000370           DELIMITED BY SIZE INTO ＣＳＶレコード
000380*       CSVレコードを項目単位に分解(","で区切る)
000390        UNSTRING ＣＳＶレコード
000400           DELIMITED BY ","
000410           INTO ＷＳー商品コード, ＷＳー倉庫コード, 
000420                ＷＳー現在庫数,   ＷＳー引当済数, 
000430                ＷＳー最終在庫更新日
000440        DISPLAY "'" ＣＳＶデータ "'"
000450*       在庫マスタへの書き込み
000460        WRITE 在庫マスタレコード FROM ＣＳＶデータ
000470        IF ファイルステータス NOT = "00"
000480           DISPLAY "マスタファイル書き込みエラー："
000490           "ファイルステータス=" ファイルステータス
000500        END-IF
000510     END-PERFORM.
000520*
000530     CLOSE 在庫マスタＣＳＶ.
000540     CLOSE 在庫マスタ.
000550     STOP RUN.