000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. 在庫マスタ更新.
000020 ENVIRONMENT DIVISION.
000030 INPUT-OUTPUT SECTION.
000040 FILE-CONTROL.
000050     SELECT 在庫マスタ ASSIGN TO "在庫マスタ.sqlite3"
000060         ORGANIZATION IS INDEXED
000070         ACCESS MODE IS DYNAMIC
000080         RECORD KEY IS Ｍ商品コード
000090         FILE STATUS IS ファイルステータス.
000100     SELECT トランザクションＣＳＶ 
000110         ASSIGN TO "トランザクションデータ.csv"
000120         ORGANIZATION IS LINE SEQUENTIAL.
000130     SELECT 発注ファイル ASSIGN TO "発注.dat"
000140         ORGANIZATION IS SEQUENTIAL.
000150     SELECT 欠品ファイル ASSIGN TO "欠品.dat"
000160         ORGANIZATION IS SEQUENTIAL.
000170 DATA DIVISION.
000180 FILE SECTION.
000190 FD 在庫マスタ.
000200 01 在庫マスタレコード.
000210     COPY 在庫レコード.
000220 FD トランザクションＣＳＶ.
000230 01 ＣＳＶレコード          PIC X(50).
000240 FD 発注ファイル.
000250 01 発注レコード.
000260     COPY 発注レコード.
000270 FD 欠品ファイル.
000280 01 欠品レコード.
000290     COPY 欠品レコード.
000300 WORKING-STORAGE SECTION.
000310 01 ファイルステータス      PIC X(2).
000320 01 ＣＳＶデータ.
000330     05 ＷＳ－商品コード    PIC X(10).
000340     05 ＷＳ－倉庫コード    PIC X(10).
000350     05 ＷＳ－トランザクション種別 PIC X(4).   *> 入庫 or 出庫
000360     05 ＷＳ－数量          PIC 9(7).
000370     05 ＷＳ－取引日        PIC 9(8).
000380     05 ＷＳ－顧客コード    PIC X(10).
000390 01 閾値                    PIC 9(7) VALUE 10.
000400 PROCEDURE DIVISION.
000410 開始処理.
000420     OPEN INPUT トランザクションＣＳＶ.
000430     OPEN I-O 在庫マスタ.
000440     OPEN OUTPUT 発注ファイル.
000450     OPEN OUTPUT 欠品ファイル.
000460     
000470     PERFORM FOREVER
000480*       CSVファイルを読み込む。AT ENDなら終了
000490        READ トランザクションＣＳＶ
000500           AT END
000510              EXIT PERFORM
000520        END-READ
000530*       CSVレコードの最後にカンマ(',')を付与する。
000540        STRING FUNCTION TRIM(ＣＳＶレコード) "," 
000550           DELIMITED BY SIZE INTO ＣＳＶレコード
000560*       CSVレコードを項目単位に分解(","で区切る)
000570        UNSTRING ＣＳＶレコード
000580           DELIMITED BY ","
000590           INTO ＷＳ－商品コード, ＷＳ－倉庫コード, 
000600                ＷＳ－トランザクション種別, ＷＳ－数量, 
000610                ＷＳ－取引日, ＷＳ－顧客コード
000620*       在庫マスタの照合
000630*       商品が見つからない場合はログを出力して次の繰り返しへ
000000        MOVE ＷＳ－商品コード TO Ｍ商品コード
000640        READ 在庫マスタ
000650           INVALID KEY 
000660              DISPLAY "不明商品: 商品コード=" ＷＳ－商品コード
000670              EXIT PERFORM CYCLE
000680        END-READ
000690*       在庫マスタの更新、および欠品データ、発注データの出力
000700        PERFORM 在庫調整処理
000710     END-PERFORM.
000720     
000730     CLOSE トランザクションＣＳＶ.
000740     CLOSE 在庫マスタ.
000750     CLOSE 発注ファイル.
000760     CLOSE 欠品ファイル.
000770     STOP RUN.
000780     
000790 在庫調整処理.
000800     DISPLAY "".
000810     DISPLAY "'" ＣＳＶデータ "'".
000820     DISPLAY "  BEFORE:" 在庫マスタレコード.
000830*    トランザクションの種別が「入庫」の場合
000840     IF ＷＳ－トランザクション種別 = "入庫"
000850        ADD ＷＳ－数量 TO Ｍ現在庫数
000860*    トランザクションの種別が「出庫」の場合
000870     ELSE
000880*       すべての数量を引き当てられる場合は、在庫量を減らす。
000890        IF Ｍ現在庫数 >= ＷＳ－数量
000900           SUBTRACT ＷＳ－数量 FROM Ｍ現在庫数
000910           ADD ＷＳ－数量 TO Ｍ引当済数
000920*       すべてを引き当てられない場合は欠品情報を出力する。
000930        ELSE
000940           MOVE ＷＳ－商品コード TO 欠品商品コード
000950           MOVE ＷＳ－倉庫コード TO 欠品倉庫コード
000960           COMPUTE 欠品数 = ＷＳ－数量 - Ｍ現在庫数
000970           MOVE ＷＳ－取引日     TO 欠品日
000980           MOVE ＷＳ－顧客コード TO 欠品顧客コード
000990           WRITE 欠品レコード
001000           MOVE 0 TO Ｍ現在庫数
001010        END-IF
001020     END-IF
001030*    最終在庫更新日を更新して、在庫マスタを更新する
001040     MOVE ＷＳ－取引日 TO Ｍ最終在庫更新日.
001050     REWRITE 在庫マスタレコード.
001060     DISPLAY "  AFTER: " 在庫マスタレコード.
001070*    在庫が閾値よりもすくないときは、発注データを出力する。
001080     IF Ｍ現在庫数 < 閾値
001090        MOVE ＷＳ－商品コード TO 発注商品コード
001100        MOVE ＷＳ－倉庫コード TO 発注倉庫コード
001110        MOVE 20 TO 発注数
001120        MOVE ＷＳ－取引日 TO 発注日
001130        WRITE 発注レコード
001140     END-IF.