000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. バッチ処理サンプル.
000020 DATA DIVISION.
000030 WORKING-STORAGE SECTION.
000040 01 PID                     PIC 9(10).
000050 01 トランザクションデータ  PIC X(100).
000060 01 発注ファイル名          PIC X(100).
000070 01 発注帳票名              PIC X(100).
000080 01 欠品ファイル名          PIC X(100).
000090 01 欠品帳票名              PIC X(100).  
000100 PROCEDURE DIVISION.
000110 MAIN00.
000120*    プロセスIDの取得
000130     CALL "CBL_GET_PID" USING PID.
000140     
000150*    環境変数の設定
000160*    set tran_file=%pid%_トランザクションデータ.csv
000170     STRING FUNCTION TRIM(PID) "_トランザクションデータ.csv"
000180       DELIMITED BY SIZE INTO トランザクションデータ.
000190     SET ENVIRONMENT "tran_file" TO トランザクションデータ.
000200
000210*    set order_file=%pid%_発注.dat
000220     STRING FUNCTION TRIM(PID) "_発注.dat" DELIMITED BY SIZE
000230                        INTO 発注ファイル名.
000240     SET ENVIRONMENT "order_file" TO 発注ファイル名.
000250
000260*    set order_text=%pid%_発注帳票.txt
000270     STRING FUNCTION TRIM(PID) "_発注帳票.txt" DELIMITED BY SIZE
000280                        INTO 発注帳票名.
000290     SET ENVIRONMENT "order_text" TO 発注帳票名.
000300
000310*    set out_of_stock_file=%pid%_欠品.dat
000320     STRING FUNCTION TRIM(PID) "_欠品.dat" DELIMITED BY SIZE
000330                        INTO 欠品ファイル名.
000340     SET ENVIRONMENT "out_of_stock_file" TO 欠品ファイル名.
000350
000360*    set out_of_stock_text=%pid%_欠品帳票.txt
000370     STRING FUNCTION TRIM(PID) "_欠品帳票.txt" DELIMITED BY SIZE
000380                        INTO 欠品帳票名.
000390     SET ENVIRONMENT "out_of_stock_text" TO 欠品帳票名.
000400     
000410     DISPLAY "トランザクションデータ: " トランザクションデータ.
000420     DISPLAY "発注ファイル名:         " 発注ファイル名.
000430     DISPLAY "欠品ファイル名:         " 欠品ファイル名.
000440     DISPLAY "発注帳票名:             " 発注帳票名.
000450     DISPLAY "欠品帳票名:             " 欠品帳票名.
000460
000470*    トランザクションデータの用意
000480     CALL "CBL_COPY_FILE" USING "トランザクションデータ.csv"
000490                                トランザクションデータ.
000500     IF RETURN-CODE NOT = 0
000510        DISPLAY "トランザクションのコピーに失敗した code=" 
000520                RETURN-CODE
000530        GO TO L-ERROR
000540     END-IF.
000550
000560*    在庫マスタ更新
000570     CALL "在庫マスタ更新2".
000580     IF RETURN-CODE NOT = 0
000590        DISPLAY "在庫マスタ更新が失敗した code=" RETURN-CODE
000600        GO TO L-ERROR
000610     END-IF.
000620
000630*    発注帳票作成
000640     CALL "発注帳票作成2".
000650     IF RETURN-CODE NOT = 0
000660        DISPLAY "発注帳票作成が失敗した code=" RETURN-CODE
000670        GO TO L-ERROR
000680     END-IF.
000690
000700*    欠品帳票作成
000710     CALL "欠品帳票作成2".
000720     IF RETURN-CODE NOT = 0
000730        DISPLAY "欠品帳票作成が失敗した code=" RETURN-CODE
000740        GO TO L-ERROR
000750     END-IF.
000760
000770 L-ERROR.
000780*    不要となったファイルの削除
000790     CALL "CBL_DELETE_FILE" USING トランザクションデータ.
000800     IF RETURN-CODE NOT = 0
000810        DISPLAY "トランザクションデータの削除に失敗した: "
000820                "ファイル名=" トランザクションデータ
000830                ", code=" RETURN-CODE
000840     END-IF.
000850*
000860     CALL "CBL_DELETE_FILE" USING 発注ファイル名.
000870     IF RETURN-CODE NOT = 0
000880        DISPLAY "発注ファイルの削除に失敗した: "
000890                "ファイル名=" 発注ファイル名
000900                ", code=" RETURN-CODE
000910     END-IF.
000920*
000930     CALL "CBL_DELETE_FILE" USING 欠品ファイル名.
000940     IF RETURN-CODE NOT = 0
000950        DISPLAY "欠品ファイルの削除に失敗した: "
000960                "ファイル名=" 欠品ファイル名
000970                ", code=" RETURN-CODE
000980     END-IF.
000990     
001000     STOP RUN.