000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. 在庫マスタ更新２.
000020 ENVIRONMENT DIVISION.
000030 INPUT-OUTPUT SECTION.
000040 FILE-CONTROL.
000050     SELECT 在庫マスタ ASSIGN TO "在庫マスタ.sqlite3"
000060         ORGANIZATION IS INDEXED
000070         ACCESS MODE IS DYNAMIC
000080         RECORD KEY IS Ｍ商品コード
000090         FILE STATUS IS ファイルステータス.
000100     SELECT トランザクションＣＳＶ 
000110         ASSIGN TO TRAN-FILE                         *> 実ファイル名をデータ名TRAN-FILEに変更
000120         ORGANIZATION IS LINE SEQUENTIAL.
000130     SELECT 発注ファイル ASSIGN TO ORDER-FILE        *> 実ファイル名をデータ名ORDER-FILEに変更
000140         ORGANIZATION IS SEQUENTIAL.                 
000150     SELECT 欠品ファイル ASSIGN TO OUT-OF-STOCK-FILE *> 実ファイル名をデータ名OUT-OF-STOCK-FILEに変更
000160         ORGANIZATION IS SEQUENTIAL.
000170 DATA DIVISION.
000180 FILE SECTION.
000190 FD 在庫マスタ.
000200 01 在庫マスタレコード.
000210     COPY 在庫レコード.
000220 FD トランザクションＣＳＶ.
000230 01 ＣＳＶレコード          PIC X(50).
000240 FD 発注ファイル.
000250 01 発注レコード.
000260     COPY 発注レコード.
000270 FD 欠品ファイル.
000280 01 欠品レコード.
000290     COPY 欠品レコード.
000300 WORKING-STORAGE SECTION.
000310 01 ファイルステータス      PIC X(2).
000320 01 ＣＳＶデータ.
000330     05 ＷＳ－商品コード    PIC X(10).
000340     05 ＷＳ－倉庫コード    PIC X(10).
000350     05 ＷＳ－トランザクション種別 PIC X(4).   *> 入庫 or 出庫
000360     05 ＷＳ－数量          PIC 9(7).
000370     05 ＷＳ－取引日        PIC 9(8).
000380     05 ＷＳ－顧客コード    PIC X(10).
000390 01 閾値                    PIC 9(7) VALUE 10.
000400 01 TRAN-FILE               PIC X(100).             *> トランザクションファイルの実ファイル名用
000410 01 ORDER-FILE              PIC X(100).             *> 発注ファイルの実ファイル名用
000420 01 OUT-OF-STOCK-FILE       PIC X(100).             *> 欠品ファイルの実ファイル名用
000430 PROCEDURE DIVISION.
000440 開始処理.
000450*    ファイル名の取得
000460     ACCEPT TRAN-FILE FROM ENVIRONMENT  "tran_file".         *> 環境変数tarn_fileの値をTRAN-FILEに設定する
000470     ACCEPT ORDER-FILE FROM ENVIRONMENT "order_file".        *> 環境変数order_fileの値をORDER-FILEに設定する
000480     ACCEPT OUT-OF-STOCK-FILE FROM ENVIRONMENT               *> 環境変数out_of_stock_fileの値を
000490                                        "out_of_stock_file". *> OUT-OF-STOCK-FILEに設定する
000500     DISPLAY "TRAN-FILE=         " TRAN-FILE.
000510     DISPLAY "ORDER-FILE=        " ORDER-FILE.
000520     DISPLAY "OUT-OF-STOCK-FILE= " OUT-OF-STOCK-FILE.
000530*    ファイルを開く
000540     OPEN INPUT トランザクションＣＳＶ.
000550     OPEN I-O 在庫マスタ.
000560     OPEN OUTPUT 発注ファイル.
000570     OPEN OUTPUT 欠品ファイル.
000580     
000590     PERFORM FOREVER
000600*       CSVファイルを読み込む。AT ENDなら終了
000610        READ トランザクションＣＳＶ
000620           AT END
000630              EXIT PERFORM
000640        END-READ
000650*       CSVレコードの最後にカンマ(',')を付与する。
000660        STRING FUNCTION TRIM(ＣＳＶレコード) "," 
000670           DELIMITED BY SIZE INTO ＣＳＶレコード
000680*       CSVレコードを項目単位に分解(","で区切る)
000690        UNSTRING ＣＳＶレコード
000700           DELIMITED BY ","
000710           INTO ＷＳ－商品コード, ＷＳ－倉庫コード, 
000720                ＷＳ－トランザクション種別, ＷＳ－数量, 
000730                ＷＳ－取引日, ＷＳ－顧客コード
000740*       在庫マスタの照合
000750*       商品が見つからない場合はログを出力して次の繰り返しへ
000760        MOVE ＷＳ－商品コード TO Ｍ商品コード
000770        READ 在庫マスタ
000780           INVALID KEY 
000790              DISPLAY "不明商品: 商品コード=" ＷＳ－商品コード
000800              EXIT PERFORM CYCLE
000810        END-READ
000820*       在庫マスタの更新、および欠品データ、発注データの出力
000830        PERFORM 在庫調整処理
000840     END-PERFORM.
000850     
000860     CLOSE トランザクションＣＳＶ.
000870     CLOSE 在庫マスタ.
000880     CLOSE 発注ファイル.
000890     CLOSE 欠品ファイル.
000900     EXIT PROGRAM.               *> 副プログラムの場合は呼ばれたプログラムに戻る
000910     STOP RUN.                   *> 主プログラムの場合は終了
000920     
000930 在庫調整処理.
000940     DISPLAY "".
000950     DISPLAY "'" ＣＳＶデータ "'".
000960     DISPLAY "  BEFORE:" 在庫マスタレコード.
000970*    トランザクションの種別が「入庫」の場合
000980     IF ＷＳ－トランザクション種別 = "入庫"
000990        ADD ＷＳ－数量 TO Ｍ現在庫数
001000*    トランザクションの種別が「出庫」の場合
001010     ELSE
001020*       すべての数量を引き当てられる場合は、在庫量を減らす。
001030        IF Ｍ現在庫数 >= ＷＳ－数量
001040           SUBTRACT ＷＳ－数量 FROM Ｍ現在庫数
001050           ADD ＷＳ－数量 TO Ｍ引当済数
001060*       すべてを引き当てられない場合は欠品情報を出力する。
001070        ELSE
001080           MOVE ＷＳ－商品コード TO 欠品商品コード
001090           MOVE ＷＳ－倉庫コード TO 欠品倉庫コード
001100           COMPUTE 欠品数 = ＷＳ－数量 - Ｍ現在庫数
001110           MOVE ＷＳ－取引日     TO 欠品日
001120           MOVE ＷＳ－顧客コード TO 欠品顧客コード
001130           WRITE 欠品レコード
001140           MOVE 0 TO Ｍ現在庫数
001150        END-IF
001160     END-IF
001170*    最終在庫更新日を更新して、在庫マスタを更新する
001180     MOVE ＷＳ－取引日 TO Ｍ最終在庫更新日.
001190     REWRITE 在庫マスタレコード.
001200     DISPLAY "  AFTER: " 在庫マスタレコード.
001210*    在庫が閾値よりもすくないときは、発注データを出力する。
001220     IF Ｍ現在庫数 < 閾値
001230        MOVE ＷＳ－商品コード TO 発注商品コード
001240        MOVE ＷＳ－倉庫コード TO 発注倉庫コード
001250        MOVE 20 TO 発注数
001260        MOVE ＷＳ－取引日 TO 発注日
001270        WRITE 発注レコード
001280     END-IF.