000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. 欠品帳票作成２.
000020 ENVIRONMENT DIVISION.
000030 INPUT-OUTPUT SECTION.
000040 FILE-CONTROL.
000050     SELECT 欠品ファイル ASSIGN TO OUT-OF-STOCK-FILE *> 実ファイル名をOUT-OF-STOCK-FILEに変更
000060         ORGANIZATION IS SEQUENTIAL.
000070
000080     SELECT 商品マスタ ASSIGN TO "商品マスタ.sqlite3"
000090         ORGANIZATION IS INDEXED
000100         ACCESS MODE IS DYNAMIC
000110         RECORD KEY IS Ｍ商品コード.
000120
000130     SELECT 倉庫マスタ ASSIGN TO "倉庫マスタ.sqlite3"
000140         ORGANIZATION IS INDEXED
000150         ACCESS MODE IS DYNAMIC
000160         RECORD KEY IS Ｍ倉庫コード.
000170
000180     SELECT 顧客マスタ ASSIGN TO "顧客マスタ.sqlite3"
000190         ORGANIZATION IS INDEXED
000200         ACCESS MODE IS DYNAMIC
000210         RECORD KEY IS Ｍ顧客コード.
000220
000230     SELECT 欠品帳票 ASSIGN TO OUT-OF-STOCK-TEXT   *> 実ファイル名をOUT-OF-STOCK-TEXTに変更
000240         ORGANIZATION IS LINE SEQUENTIAL.
000250
000260 DATA DIVISION.
000270 FILE SECTION.
000280 FD 欠品ファイル.
000290 01 欠品レコード.
000300    COPY 欠品レコード.
000310
000320 FD 商品マスタ.
000330 01 商品マスタレコード.
000340     COPY 商品レコード.
000350
000360 FD 倉庫マスタ.
000370 01 倉庫マスタレコード.
000380    COPY 倉庫レコード.
000390
000400 FD 顧客マスタ.
000410 01 顧客マスタレコード.
000420    COPY 顧客レコード.
000430
000440 FD 欠品帳票.
000450 01 欠品帳票レコード PIC X(120).
000460
000470 WORKING-STORAGE SECTION.
000480 01 ヘッダ行           PIC X(90) VALUE
000490                          "項番 顧客コード 顧客名               "
000500                        & "商品コード "
000510                        & "商品名                     " 
000520                        & "倉庫名    " 
000530                        & "欠品数 欠品日".
000540 01 区切り線           PIC X(100) VALUE ALL "-".
000550 01 明細行.
000560    02 明細項番        PIC ZZZ9 VALUE 1.
000570    02                 PIC X(1) VALUE SPACE.
000580    02 明細顧客コード  PIC X(10).
000590    02                 PIC X(1) VALUE SPACE.
000600    02 明細顧客名      PIC N(10).
000610    02                 PIC X(1) VALUE SPACE.
000620    02 明細商品コード  PIC X(10).
000630    02                 PIC X(1) VALUE SPACE.
000640    02 明細商品名      PIC N(13).
000650    02                 PIC X(1) VALUE SPACE.
000660    02 明細倉庫名      PIC N(5).
000670    02                 PIC X(1) VALUE SPACE.
000680    02 明細発注数      PIC ZZZZ9.
000690    02                 PIC X(1) VALUE SPACE.
000700    02 明細発注日      PIC 99/99/99.
000710*
000720 01 OUT-OF-STOCK-FILE  PIC X(100).   *> 欠品ファイルの実ファイル名用
000730 01 OUT-OF-STOCK-TEXT  PIC X(100).   *> 欠品帳票の実ファイル名用
000740 PROCEDURE DIVISION.
000750 開始処理.
000760     ACCEPT OUT-OF-STOCK-FILE FROM ENVIRONMENT 
000770                                   "out_of_stock_file".
000780     ACCEPT OUT-OF-STOCK-TEXT FROM ENVIRONMENT 
000790                                   "out_of_stock_text".
000800*
000810     OPEN INPUT 欠品ファイル.
000820     OPEN INPUT 商品マスタ.
000830     OPEN INPUT 倉庫マスタ.
000840     OPEN INPUT 顧客マスタ.
000850     OPEN OUTPUT 欠品帳票.
000790
000800     WRITE 欠品帳票レコード FROM 区切り線.
000810     WRITE 欠品帳票レコード FROM ヘッダ行.
000820     WRITE 欠品帳票レコード FROM 区切り線.
000830
000840     PERFORM FOREVER
000850*      発注ファイル読込。AT ENDとなったら終了。
000860       READ 欠品ファイル
000870         AT END 
000880           EXIT PERFORM
000890       END-READ
000900       MOVE SPACES TO 明細商品名
000910       MOVE SPACES TO 明細倉庫名
000920*      商品マスタより商品名を検索
000930       MOVE 欠品商品コード TO Ｍ商品コード
000940       READ 商品マスタ
000950         INVALID KEY 
000960           MOVE "不明" TO 明細商品名
000970           DISPLAY "不明:" 欠品商品コード
000980         NOT INVALID KEY 
000990           MOVE Ｍ商品名 OF 商品マスタ TO 明細商品名 *> 英数字項目から日本語項目への転記なので
001000                                                     *> 半角文字は空白も含めて全角文字になる
001010       END-READ
001020*      倉庫マスタより倉庫名を検索。
001030       MOVE 欠品倉庫コード TO Ｍ倉庫コード
001040       READ 倉庫マスタ
001050         INVALID KEY 
001060           MOVE "不明" TO 明細倉庫名
001070           DISPLAY "不明:" 欠品倉庫コード
001080         NOT INVALID KEY 
001090           MOVE Ｍ倉庫名 TO 明細倉庫名               *> 英数字項目から日本語項目への転記なので
001100                                                     *> 半角文字は空白も含めて全角文字になる
001110       END-READ
001120*      顧客マスタより顧客名を検索。
001130       MOVE 欠品顧客コード TO Ｍ顧客コード
001140       READ 顧客マスタ
001150         INVALID KEY 
001160           MOVE "不明" TO 明細顧客名
001170           DISPLAY "不明:" 欠品顧客コード
001180         NOT INVALID KEY 
001190           MOVE Ｍ顧客名 TO 明細顧客名               *> 英数字項目から日本語項目への転記なので
001200                                                     *> 半角文字は空白も含めて全角文字になる
001210       END-READ
001220*      明細行の作成
001230       MOVE 欠品商品コード TO 明細商品コード
001240       MOVE 欠品顧客コード TO 明細顧客コード
001250       MOVE 欠品数         TO 明細発注数
001260       MOVE 欠品日         TO 明細発注日
001270       WRITE 欠品帳票レコード FROM 明細行
001280
001290       ADD 1 TO 明細項番
001300           
001310     END-PERFORM.
001320     WRITE 欠品帳票レコード FROM 区切り線.
001330
001340     CLOSE 欠品ファイル.
001350     CLOSE 商品マスタ.
001360     CLOSE 倉庫マスタ.
001370     CLOSE 顧客マスタ.
001380     CLOSE 欠品帳票.
001390     EXIT PROGRAM.