000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. 発注帳票作成２.
000020 ENVIRONMENT DIVISION.
000030 INPUT-OUTPUT SECTION.
000040 FILE-CONTROL.
000050     SELECT 発注ファイル ASSIGN TO ORDER-FILE     *> 実ファイル名をORDER-FILEに変更
000060         ORGANIZATION IS SEQUENTIAL.
000070
000080     SELECT 商品マスタ ASSIGN TO "商品マスタ.sqlite3"
000090         ORGANIZATION IS INDEXED
000100         ACCESS MODE IS DYNAMIC
000110         RECORD KEY IS Ｍ商品コード.
000120
000130     SELECT 倉庫マスタ ASSIGN TO "倉庫マスタ.sqlite3"
000140         ORGANIZATION IS INDEXED
000150         ACCESS MODE IS DYNAMIC
000160         RECORD KEY IS Ｍ倉庫コード.
000170
000180     SELECT 発注帳票 ASSIGN TO ORDER-TEXT        *> 実ファイル名をORDER-TEXTに変更
000190         ORGANIZATION IS LINE SEQUENTIAL.
000200
000210 DATA DIVISION.
000220 FILE SECTION.
000230 FD 発注ファイル.
000240 01 発注レコード.
000250    COPY 発注レコード.
000260
000270 FD 商品マスタ.
000280 01 商品マスタレコード.
000290     COPY 商品レコード.
000300
000310 FD 倉庫マスタ.
000320 01 倉庫マスタレコード.
000330    COPY 倉庫レコード.
000340
000350 FD 発注帳票.
000360 01 発注帳票レコード PIC X(90).
000370
000380 WORKING-STORAGE SECTION.
000390 01 ヘッダ行           PIC X(90) VALUE
000400                          "項番 商品コード "
000410                        & "商品名                               " 
000420                        & "倉庫名              "
000430                        & "発注数 発注日".
000440 01 区切り線           PIC X(90) VALUE ALL "-".
000450 01 明細行.
000460    02 明細項番        PIC ZZZ9 VALUE 1.
000470    02                 PIC X(1) VALUE SPACE.
000480    02 明細商品コード  PIC X(10).
000490    02                 PIC X(1) VALUE SPACE.
000500    02 明細商品名      PIC N(18).
000510    02                 PIC X(1) VALUE SPACE.
000520    02 明細倉庫名      PIC N(10).
000530    02                 PIC X(1) VALUE SPACE.
000540    02 明細発注数      PIC ZZZZ9.
000550    02                 PIC X(1) VALUE SPACE.
000560    02 明細発注日      PIC 99/99/99.
000570*
000580 01 ORDER-FILE         PIC X(100).             *> 発注ファイルの実ファイル名用
000590 01 ORDER-TEXT         PIC X(100).             *> 発注帳票テキストの実ファイル名用
000600 PROCEDURE DIVISION.
000610 開始処理.
000620     ACCEPT ORDER-FILE FROM ENVIRONMENT "order_file". *> 環境変数order_fileの値を取得
000630     ACCEPT ORDER-TEXT FROM ENVIRONMENT "order_text". *> 環境変数order_textの値を取得  
000640*
000650     OPEN INPUT 発注ファイル.
000660     OPEN INPUT 商品マスタ.
000670     OPEN INPUT 倉庫マスタ.
000680     OPEN OUTPUT 発注帳票.
000690
000700     WRITE 発注帳票レコード FROM 区切り線.
000710     WRITE 発注帳票レコード FROM ヘッダ行.
000720     WRITE 発注帳票レコード FROM 区切り線.
000730
000740     PERFORM FOREVER
000750*      発注ファイル読込。AT ENDとなったら終了。
000760       READ 発注ファイル
000770         AT END 
000780           EXIT PERFORM
000790       END-READ
000800       MOVE SPACES TO 明細商品名
000810       MOVE SPACES TO 明細倉庫名
000820*      商品マスタより商品名を検索
000830       MOVE 発注商品コード TO Ｍ商品コード
000840       READ 商品マスタ
000850         INVALID KEY 
000860           MOVE "不明" TO 明細商品名
000870           DISPLAY "不明:" 発注商品コード
000880         NOT INVALID KEY 
000890           MOVE Ｍ商品名 OF 商品マスタ TO 明細商品名 *> 英数字項目から日本語項目への転記なので
000900                                                     *> 半角文字は空白も含めて全角文字になる
000910       END-READ
000920*      倉庫マスタより倉庫名を検索。
000930       MOVE 発注倉庫コード TO Ｍ倉庫コード
000940       READ 倉庫マスタ
000950         INVALID KEY 
000960           MOVE "不明" TO 明細倉庫名
000970           DISPLAY "不明:" 発注倉庫コード
000980         NOT INVALID KEY 
000990           MOVE Ｍ倉庫名 TO 明細倉庫名               *> 英数字項目から日本語項目への転記なので
001000                                                     *> 半角文字は空白も含めて全角文字になる
001010       END-READ
001020*      明細行の作成
001030       MOVE 発注商品コード TO 明細商品コード
001040       MOVE 発注数         TO 明細発注数
001050       MOVE 発注日         TO 明細発注日
001060       WRITE 発注帳票レコード FROM 明細行
001070
001080       ADD 1 TO 明細項番
001090           
001100     END-PERFORM.
001110     WRITE 発注帳票レコード FROM 区切り線.
001120
001130     CLOSE 発注ファイル.
001140     CLOSE 商品マスタ.
001150     CLOSE 倉庫マスタ.
001160     CLOSE 発注帳票.
001170     EXIT PROGRAM.                                  *> 副プログラムの場合は呼ばれたプログラムに戻る